diff --git a/web/pgadmin/tools/datagrid/static/js/datagrid.js b/web/pgadmin/tools/datagrid/static/js/datagrid.js
index 5d88831e6..9636029ad 100644
--- a/web/pgadmin/tools/datagrid/static/js/datagrid.js
+++ b/web/pgadmin/tools/datagrid/static/js/datagrid.js
@@ -270,6 +270,10 @@ define('pgadmin.datagrid', [
             });
           });
 
+          queryToolPanel.on(wcDocker.EVENT.VISIBILITY_CHANGED, function() {
+            queryToolPanel.trigger(wcDocker.EVENT.RESIZED);
+          });
+
           commonUtils.registerDetachEvent(queryToolPanel);
 
           // Listen on the panelRename event.
diff --git a/web/pgadmin/tools/sqleditor/static/js/sqleditor.js b/web/pgadmin/tools/sqleditor/static/js/sqleditor.js
index 40c269d14..2d4593883 100644
--- a/web/pgadmin/tools/sqleditor/static/js/sqleditor.js
+++ b/web/pgadmin/tools/sqleditor/static/js/sqleditor.js
@@ -1418,6 +1418,18 @@ define('tools.querytool', [
         }
       });
 
+      self.data_output_panel.on(wcDocker.EVENT.RESIZED, function() {
+        // Resize grid only when 'Data Output' panel is visible.
+        if (self.data_output_panel.isVisible()) {
+          if (self.preferences.column_data_auto_resize === 'by_data') {
+            grid.resizeAllColumns && grid.resizeAllColumns(
+              self.preferences.column_data_max_width, self.max_width_changed);
+          }else{
+            self.grid.resizeAllColumns && self.grid.resizeAllColumns();
+          }
+        }
+      });
+
       // Resize SlickGrid when output Panel gets focus
       self.data_output_panel.on(wcDocker.EVENT.VISIBILITY_CHANGED, function() {
         // Resize grid only if output panel is visible
